/*
 * libkarma/fdb.h
 * 
 * Copyright (c) Frank Zschockelt <libkarma@freakysoft.de> 2005
 * 
 * You may distribute and modify this program under the terms of 
 * the GNU GPL, version 2 or later.
 * 
 */
#include <stdlib.h>
#include <string.h>
#include <zlib.h>

#include "properties.h"
#include "util.h"
#include "fdb.h"

/*
 * fid:fid_generation path
 */

int lk_fdb_load(void)
{
	gzFile fdb_file;
	char * fname;
	char * buf=NULL,*p,*n_tok;
	int read,size=0;
	uint32_t fid;
	char * fid_gen;
	HASH * tmp;
	
	/*
	 * Datenbank vom Karma laden
	*/
	fname=lk_path_string("libkarma_fdb.gz");
	fdb_file=gzopen(fname, "r");
	if(fdb_file){
		do{
			buf=realloc(buf, size+8192);
			read=gzread(fdb_file, &buf[size], 8192);
			size+=read;
		}while(read > 0);	
		gzclose(fdb_file);
		
		if((read == -1) || (size == 0)){
			free(buf);
			free(fname);
			return read;
		}
		buf[size]='\0';
		p=strtok_r(buf, ":", &n_tok);
		fid=(uint32_t)atol(p);
		fid_gen=strtok_r(NULL, " ", &n_tok);
		p=strtok_r(NULL, "\n", &n_tok);
		if((tmp=lk_properties_idsearch(fid)))
			if(strcmp(p, lk_properties_get_property_hash(tmp, "fid_generation"))==0)
				lk_properties_set_property_hash(tmp, "path", p);
		while(p!=NULL){
			p=strtok_r(NULL, ":", &n_tok);
			if(p){
				fid=(uint32_t)atol(p);
				fid_gen=strtok_r(NULL, " ", &n_tok);
				p=strtok_r(NULL, "\n", &n_tok);
				if((tmp=lk_properties_idsearch(fid)))
					if(strcmp(p, lk_properties_get_property_hash(tmp, "fid_generation"))==0)
						lk_properties_set_property_hash(tmp, "path", p);
			}
		}
		free(buf);
	}
	free(fname);
	return 0;
}

int lk_fdb_save(void)
{
	gzFile fdb_file;
	char * fname;
	char * p;
	uint32_t * fdb;
	HASH * tmp;
	int i=0;
	
	fname=lk_path_string("libkarma_fdb.gz");
	fdb=lk_properties_andOrSearch(EXACT|ORS, NULL, "path", "");
	if(fdb){
		fdb_file=gzopen(fname, "w");
		while(fdb[i]){
			p=simple_itoa(fdb[i]);
			tmp=lk_properties_idsearch(fdb[i]);
			gzwrite(fdb_file, p, strlen(p));
			gzwrite(fdb_file, ":", 1); 
			p=lk_properties_get_property_hash(tmp, "fid_generation");
			gzwrite(fdb_file, p, strlen(p));
			gzwrite(fdb_file, " ", 1);
			p=lk_properties_get_property_hash(tmp, "path");
			gzwrite(fdb_file, p, strlen(p));
			gzwrite(fdb_file, "\n", 1);
			/*tmp=tmp->e;*/
			++i;
			
		}
		free(fdb);
		/*
		while(tmp != NULL){
			p=simple_itoa(tmp->fid);
			gzwrite(fdb_file, p, strlen(p));
			gzwrite(fdb_file, ":", 1); 
			p=simple_itoa(tmp->fid_generation);
			gzwrite(fdb_file, p, strlen(p));
			gzwrite(fdb_file, " ", 1);
			gzwrite(fdb_file, tmp->filename, strlen(tmp->filename));
			gzwrite(fdb_file, "\n", 1);
			tmp=tmp->e;
		}
		*/
		/*gzwrite(fdb_file, "\n", 1);*/
		gzclose(fdb_file);
	}
	/*
	 * Datenbank auf Karma als Taxifile kopieren...
	 */
	free(fname);
	return 0;
}
