#include <inttypes.h>
typedef struct{
	char * name;
	char * playlist;
	unsigned int length;
	uint32_t fid;
} playlist;

char *	 	lk_playlist_escape	(char * data, unsigned int length);
unsigned int	lk_playlist_unescape	(char * str, char ** data);

playlist * 	lk_playlist_create	(char * name);
playlist *	lk_playlist_read	(char * name);
playlist * 	lk_playlist_fid_read	(uint32_t fid);
int		lk_playlist_free	(playlist ** pl);
int		lk_playlist_set_name	(playlist * pl, char * name);
char *		lk_playlist_get_name	(playlist * pl);
int 		lk_playlist_clear	(playlist * pl);
int		lk_playlist_delete	(playlist * pl, int karma);
int 		lk_playlist_count	(playlist * pl);
int 		lk_playlist_get_item	(playlist * pl, unsigned int n, uint32_t *fid, uint32_t * fid_generation);
int 		lk_playlist_set_item	(playlist * pl, unsigned int n, uint32_t fid, uint32_t fid_generation);
int 		lk_playlist_append	(playlist * pl, uint32_t fid, uint32_t fid_generation);
int 		lk_playlist_remove	(playlist * pl, unsigned int n);
int 		lk_playlist_insert	(playlist * pl, unsigned int n, uint32_t fid, uint32_t fid_generation);
int 		lk_playlist_write	(playlist * pl, int karma);
