/*
 * libkarma/properties.h
 * 
 * Copyright (c) Frank Zschockelt <libkarma@freakysoft.de> 2004
 * 
 * You may distribute and modify this program under the terms of 
 * the GNU GPL, version 2 or later.
 * 
 */
#include <iconv.h>
#include <inttypes.h>

#include "hash.h"

#ifdef __cplusplus
extern "C" {
#endif

void     lk_properties_init     (void);
void     lk_properties_destroy  (void);
/*
char *   lk_properties_get_codeset     (void);
void     lk_properties_set_codeset      (char * codeset);
*/
uint32_t lk_properties_import   (char * properties);
char *   lk_properties_export     (uint32_t id);

uint32_t lk_properties_getnextfid          (void);

uint32_t lk_properties_new_property        (void);
int      lk_properties_del_property     (uint32_t id);
char *   lk_properties_get_property        (uint32_t id, char * key);
char *   lk_properties_get_property_hash   (HASH * p, char * key);
int      lk_properties_set_property     (uint32_t id, char * property, char * data);
void     lk_properties_set_property_hash(HASH * p, char * property, char * data);

HASH *   lk_properties_idsearch            (uint32_t fid);

int      lk_properties_load     (void);
int      lk_properties_save     (void);
void     lk_properties_inc_devgeneration(void);
int      lk_properties_cache_obsolete      (char *device_settings);
int      lk_properties_db_changed          (char *device_settings);

                             /*      Exact/approximate And/Or search support: */
uint32_t *lk_properties_andOrSearch(int mode, 
				    uint32_t *search_in, char *key, char *data);
#define ORS    0                      /* mode == 00 = APPROX|ORS:  Approx,Or  */
#define ANDS   1                      /* mode == 01 = APPROX|ANDS: Approx,And */
#define APPROX 0                      /* mode == 10 =  EXACT|ORS:   Exact,Or  */
#define EXACT  2                      /* mode == 11 =  EXACT|ANDS:  Exact,And */

#ifdef __cplusplus
}
#endif  /* C++ */

